// dsc_can4lp_xt.c : Defines the entry point for the console application.
//

#include "stdafx.h"

#include "ExportHeader.h"

unsigned int base_address = 0x7000;
unsigned int diobase_address = 0x340;


unsigned int flag; 

CANCONFIG canconfig;


#define INVALID_HANDLE_VALUE ((HANDLE)(LONG_PTR)-1)


int main()
{
	char input_buffer[20];
	char output_buffer[20];
	char qbuf[20];
	char config_buffer[20];
	char dio_buffer[20];
	int index=0;
	int port=0;
	int brate_index=0;
	int i=0,j=0,k=0;
	int mode =0;
	int temp;
	BOOL success ;
	int delay;

	HANDLE device_handle;
	int ret;
	FILE *fp = NULL;
	FILE *fp1 = NULL;
	char txbuff[256];
	char txbuff1[256];
	unsigned char  msgType,Tb_Type;
	unsigned int can_id;
	unsigned char len;
	int rtr;
	unsigned short board_ver;
	unsigned short fpga_ver;

	CANMESSAGE Tx;
	CANMESSAGE Rx;
	can_device_stats stats;
	char *RxFile = "CANRX_log.txt",Rxfilename[50];
	char *TxFile = "CANTX_log.txt",Txfilename[50];
	memset(&Tx,0,sizeof(CANMESSAGE));

	printf ("Janus-MM-4LP-XT Demo Application \n\n" );
	
	device_handle = JNMMCANOpen(&flag);
	if (device_handle == INVALID_HANDLE_VALUE)
	{
		return 0;
	}
		
	if(flag == 1 ) // ISA device 	
	{
		printf("Janus-MM-4LP-XT-ISA device opened \n\n");
		printf ( "Enter the base address ( 0xE000,0x1000,0x2000,0x3000,0x4000,0x5000,0x6000,default 0x7000  , hit ENTER ) : " );
		fgets ( input_buffer, 20, stdin );

		if ( input_buffer[0] == '\n' )
		{
			printf("base address default with 0x7000  \n");
		}
		else
		{
			sscanf( input_buffer, "%lx", &base_address );
		}
		JNMMCANBaseAddrInit(base_address);

		printf("Enter the DIObase address (0x0100,0x0140,0x0180,0x01C0,0x0200,0x0240,0x0300,default= 0x0340 , hit ENTER) : ");
		fgets(dio_buffer, 20, stdin);

		if (dio_buffer[0] == '\n')
		{
			printf("DIOBase address default with 0x0340  \n");
		}
		else
		{
			sscanf(dio_buffer, "%lx", &diobase_address);
		}
		JNMMCANDIOAddrInit(diobase_address);
		
	}
	else
		printf("Janus-MM-4LP-XT-PCI device opened \n\n");
	
	printf("Enter the CAN Port number [0-CAN0,1-CAN1,2-CAN2,3-CAN3]: " );
	fgets( input_buffer, 20, stdin );
	if( input_buffer[0] == '\n' )
	{
		printf("index  default with 0  \n");
	}
	else
	{
		sscanf( input_buffer, "%lx", &port );
	}
	canconfig.Can_ch = port;
	
	
//do{			
	printf("Enter the baudrate for CAN Port %d  [0-1M,1-800K,2-500k,3-250K,4-125K,5-100K,6-50k,7-20K,8-10K] : ",canconfig.Can_ch );
	fgets(input_buffer, 20, stdin );
	if ( input_buffer[0] == '\n' )
	{
		printf("index defualt with 0 \n");
	}
	else
	{
		sscanf(input_buffer, "%lx", &brate_index );
	}
	canconfig.BaudRate = brate_index;
	printf("Enter the CAN Operation [0-Tx,1-RX] :");
	fgets ( input_buffer, 20, stdin );
	if ( input_buffer[0] == '\n' )
	{
		printf("TX mode is enabled Default  \n");
		mode = 0;
	}
	else
	{
		sscanf( input_buffer, "%x", &mode );
	}
	
	success = JNMMCANConfig(device_handle, canconfig); 
	if(success == FALSE)
	{
		printf("JNMMCANConfig failure \n");
	}
	
	if(mode==0)// Tx_mode Enabled
	{
		fp=fopen(TxFile,"w");
		if(fp==NULL)
		{
			perror("fopen:");
		}
		fflush(fp);
		sprintf(txbuff," CAN ID   Len      Data                          \n");
		fprintf(fp,"%s",txbuff);
		
		printf ( "Enter the CAN %d Message Type [0-STD,1-EXT] :",canconfig.Can_ch);
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			msgType = 0;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			msgType = temp;	
		}
		printf ( "Enter the CAN %d Transmit buffer type(Hex)[0-PTB,1-STB]  : ",canconfig.Can_ch);
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			Tb_Type = 0;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			Tb_Type = temp;	
		}
		printf ("Enter the CAN %d MSG_ID (Hex) : ",canconfig.Can_ch);
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			can_id = 0x7b;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			can_id = temp;	
		}
		
		printf ( "Enter the RTR  [0-Disable,1-Enable] :" );
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			rtr = 0x0;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			rtr = temp;	
		}
		printf ( "Enter the Data Length (Hex) :" );
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			len = 0x8;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			len = temp;	
		}
		if(len >8)
		{
			printf("Data length is greater than 8 \n");
			return 0;
		}
		printf("Press 'Q' to end the operation \n");

		i=0;
	//	for(i=0;i<1024;i++)
		while(!kbhit())
		{
		Tx.Can_ch = canconfig.Can_ch;
		Tx.Tb_Type = Tb_Type;
		Tx.Msg_type =msgType;
		Tx.Msg_ID = can_id;
		Tx.Rtr    = rtr;
		Tx.Msg_len = len;
		for(j=0;j<Tx.Msg_len;j++)
				Tx.Data[j] = i+j;			

		ret = JNMMCANTX(device_handle,&Tx);
		if(ret == -1)
		{
			printf("JNMMCANTX failure \n");
		}
		if(ret>0)
		{
			sprintf(txbuff," %x   %x    0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x  ",Tx.Msg_ID,Tx.Msg_len,Tx.Data[0],Tx.Data[1],Tx.Data[2],Tx.Data[3],Tx.Data[4],Tx.Data[5],Tx.Data[6],Tx.Data[7]);
			fprintf(fp,"%s \n",txbuff);
		}
	//	Sleep(delay); // milli-sec
		if(i>15)
		{
			i=0;
		}
		i++;
		//fclose(fp);
		//printf("\n");
		//CancelIo(device_handle);
	}
		fgets(qbuf,20,stdin);
		printf("Tx log has been saved to CANTx_log.txt\n");
		fclose(fp);
	}
	else
	{
		
		fp1=fopen(RxFile,"w");
		if(fp1==NULL)
		{
			perror("fopen:");
		}
		fflush(fp1);
		sprintf(txbuff1," CAN ID   Len      Data                           \n");
		fprintf(fp1,"%s",txbuff1);
		//printf("CAN %d selected for RX\n",canconfig.Can_ch);
		printf("Press Any key to terminate the application \n");
		i=0;
		while(!kbhit())
		{
		memset(&Rx,0,sizeof(CANMESSAGE));
		Rx.Can_ch = canconfig.Can_ch;
		ret = JNMMCANRX(device_handle,&Rx);
		if(ret == 1)
		{
			printf("JNMMCANRX failure \n");
		}
		if(ret !=0)
		{
			if(Rx.Msg_ID !=0){
			//printf("CANID (Hex): 0x%x\n",Rx.Msg_ID);
			//printf("Length (Hex):0x%x\n",Rx.Msg_len);
			//printf("Data Receive :  ");
			//for(i=0;i< Rx.Msg_len;i++)
			//printf("0x%x:",Rx.Data[i]); 
				strcat(txbuff1," ");
				sprintf(txbuff1,"%x   %x   0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x   ",Rx.Msg_ID,Rx.Msg_len,Rx.Data[0],Rx.Data[1],Rx.Data[2],Rx.Data[3],Rx.Data[4],Rx.Data[5],Rx.Data[6],Rx.Data[7]); 
				fprintf(fp1," %s \n",txbuff1); 
			}
		}
		
		//if(ret==0)
		//	break;
			
			
		//Sleep(delay); // milli-sec
		
		//fclose(fp1);
	}
		printf("\nRX log has been saved to CANRX_log file\n");
		fclose(fp1);
	}
	//printf("Press enter key to repeat or 'q' to quit :");
	//fgets(output_buffer,20,stdin);
	//}while(output_buffer[0] !='q');
	//fclose(fp);
	ret = JNMMCANErrorStat(device_handle,canconfig, &stats);
	if(ret>=0)
	{
	printf("\nJNMM CAN Device Stats Details \n");
	printf("Txpackets  =%d \n",stats.txpackets);
	printf("RxPackets  =%d \n",stats.rxpackets);
	}

	JNMMCANClose(device_handle);
	return 0;
}

